package example;

import java.util.*;
import java.lang.reflect.*;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.table.*;

public class Window extends javax.swing.JFrame {

    public Window() {
        initComponents();
    }

     private void run ()
    {
        Parser p = new Parser (input.getText ());
        output.setText ("");
        try
        {
            Arit a = p.statement();
            displayTree (a);
            output.append("O.K.");
        }
        catch (RuntimeException ex)
        {
            output.append(ex.toString ());
        }
        
    }
    
    DefaultTreeModel m; 
    
    private void displayTree (Arit a)
    {
       DefaultMutableTreeNode root = displayBranch (a) ;
       m = new DefaultTreeModel (root);
       tree.setModel (m);
    }

    private DefaultMutableTreeNode displayBranch (Arit a)
    {   
       DefaultMutableTreeNode node = new DefaultMutableTreeNode (a);
       if (a.left != null)
             node.add (displayBranch (a.left)) ;
       if (a.middle != null)
             node.add (displayBranch (a.middle)) ;
       if (a.right != null)
             node.add (displayBranch (a.right)) ;
       return node;
    } 
    
    DefaultTableModel tm;
    
    private void displayTable (Object obj)
    {
        
        Vector columns = new Vector ();
        columns.add ("Name");
        columns.add ("Value");
        
        Vector data = new Vector ();
 
        Class cls = obj.getClass();
        for (Field field : cls.getFields())
        {
           String name = field.getName ();
           String value = "";
            
            try 
            {
                Object answer = field.get (obj);
                if (answer != null)
                    value = answer.toString();
            }
            catch (IllegalArgumentException ex) { }
            catch (IllegalAccessException ex) { }
            
           Vector line = new Vector ();
           line.add (name);
           line.add (value);
           data.add (line);
        }
        
        tm = new DefaultTableModel (data, columns);
        table.setModel (tm);
    
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        toolbar = new javax.swing.JPanel();
        runButton = new javax.swing.JButton();
        jSplitPane1 = new javax.swing.JSplitPane();
        jSplitPane2 = new javax.swing.JSplitPane();
        jSplitPane3 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        tree = new javax.swing.JTree();
        jScrollPane2 = new javax.swing.JScrollPane();
        input = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        table = new javax.swing.JTable();
        jScrollPane4 = new javax.swing.JScrollPane();
        output = new javax.swing.JTextArea();
        maniMenu = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        runMenuItem = new javax.swing.JMenu();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        runButton.setText("Run");
        runButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout toolbarLayout = new javax.swing.GroupLayout(toolbar);
        toolbar.setLayout(toolbarLayout);
        toolbarLayout.setHorizontalGroup(
            toolbarLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(toolbarLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(runButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        toolbarLayout.setVerticalGroup(
            toolbarLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(toolbarLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(runButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jSplitPane1.setDividerLocation(400);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setResizeWeight(1.0);

        jSplitPane2.setDividerLocation(600);
        jSplitPane2.setResizeWeight(1.0);

        jSplitPane3.setDividerLocation(200);

        tree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                treeValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(tree);

        jSplitPane3.setLeftComponent(jScrollPane1);

        input.setColumns(20);
        input.setFont(new java.awt.Font("Monospaced", 0, 24)); // NOI18N
        input.setRows(5);
        input.setText("if (a) b = 1; else c = 2;");
        jScrollPane2.setViewportView(input);

        jSplitPane3.setRightComponent(jScrollPane2);

        jSplitPane2.setLeftComponent(jSplitPane3);

        table.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane3.setViewportView(table);

        jSplitPane2.setRightComponent(jScrollPane3);

        jSplitPane1.setTopComponent(jSplitPane2);

        output.setColumns(20);
        output.setRows(5);
        jScrollPane4.setViewportView(output);

        jSplitPane1.setRightComponent(jScrollPane4);

        fileMenu.setText("File");

        runMenuItem.setText("Run");
        runMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(runMenuItem);

        maniMenu.add(fileMenu);

        setJMenuBar(maniMenu);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(toolbar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 800, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(toolbar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 528, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void runButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runButtonActionPerformed
        run ();
    }//GEN-LAST:event_runButtonActionPerformed

    private void treeValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_treeValueChanged
        TreePath[] paths = evt.getPaths();
        for (TreePath path : paths)
            if (evt.isAddedPath(path))
            {
                Object obj = path.getLastPathComponent();
                if (obj instanceof DefaultMutableTreeNode)
                {
                    DefaultMutableTreeNode node = (DefaultMutableTreeNode) obj;
                    displayTable (node.getUserObject());
                }
            }
    }//GEN-LAST:event_treeValueChanged

    private void runMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runMenuItemActionPerformed
        run ();
    }//GEN-LAST:event_runMenuItemActionPerformed

    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        /*
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        */
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Window().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu fileMenu;
    private javax.swing.JTextArea input;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JSplitPane jSplitPane3;
    private javax.swing.JMenuBar maniMenu;
    private javax.swing.JTextArea output;
    private javax.swing.JButton runButton;
    private javax.swing.JMenu runMenuItem;
    private javax.swing.JTable table;
    private javax.swing.JPanel toolbar;
    private javax.swing.JTree tree;
    // End of variables declaration//GEN-END:variables
}
